#ifndef _ADT_FIFO_H_
#define _ADT_FIFO_H_

#include <stddef.h>

typedef struct tADTFifo {
  void* pBufBegin;
  void* pBufEnd;
  size_t SizeOfItem;
  void* pBufWrite;
  void* pBufRead;
  int PowerOf2DivShift;
  size_t SizeOfBuf;
  size_t ItemsPerBuffer;
} tADTFifo;

extern int    ADTFifo_Init (tADTFifo* pFifo, void* pBufBegin, size_t SizeOfItem,
                            size_t ItemsPerBuffer);
extern size_t ADTFifo_ReadAvail (tADTFifo* pFifo);
extern size_t ADTFifo_WriteAvail (tADTFifo* pFifo);
extern void   ADTFifo_Read (tADTFifo* pFifo, void* pItem);
extern void   ADTFifo_Write (tADTFifo* pFifo, const void* pItem);

#endif // _ADT_FIFO_H_
