#ifndef _RECT_SET_H_
#define _RECT_SET_H_

#include "../ComTypes.h"
#include "../ComDefs.h"

typedef struct tRectSetElement {
  int x1, y1;   // top left point (min x, min y)
  int x2, y2;   // bottom right point (max x, max y)
} tRectSetElement;

extern void RectSet_GetBoundRect (const tRectSetElement* pRect1, const tRectSetElement* pRect2, tRectSetElement* pBoundRect);
extern int  RectSet_GetIntersectRect (const tRectSetElement* pRect1, const tRectSetElement* pRect2, tRectSetElement* pIntersectRect);
extern int  RectSet_GetDifferenceRects (const tRectSetElement* pRect1, const tRectSetElement* pRect2, tRectSetElement pDiffRect[]);

#endif // _RECT_SET_H_
