#include "StatText.h"
#include <string.h>

void DrawWinStaticText (tWinManager* pWinManager,
                        tWindow* pWindow, const tRectSetElement* pDrawRect);

void InitWindowStaticText (tWinStaticText* pWindow,
                           int x1, int y1, int x2, int y2,
                           const char* pText,
                           uint32 BackgroundColor, uint32 TextColor,
                           const uchar pFont8x16[256*16])
{
  InitWindow (&pWindow->Window, x1, y1, x2, y2, wzg_WINDOW,
              &DrawWinStaticText, NULL);
  pWindow->pText = pText;
  pWindow->BackgroundColor = BackgroundColor;
  pWindow->TextColor = TextColor;
  pWindow->TextStrLen = strlen (pText);
  pWindow->pFont8x16 = pFont8x16;
}

void DrawWinStaticText (tWinManager* pWinManager,
                        tWindow* pWindow, const tRectSetElement* pDrawRect)
{
  tWinStaticText* pW = (tWinStaticText*)pWindow;

  Display_Text (pWinManager->pDisplay,
                pWindow->Rect.x1, pWindow->Rect.y1, pWindow->Rect.x2, pWindow->Rect.y2,
                pDrawRect->x1, pDrawRect->y1, pDrawRect->x2, pDrawRect->y2,
                pW->pText, pW->TextStrLen,
                pW->BackgroundColor, pW->TextColor,
                pW->pFont8x16);
}

