#include "WinMngr.h"

#define B 0
#define W 0xFFFFFFUL
static const int32 aMousePointerNormal[] =
{
// Format:      Y, X, L, colors
//              X - offset from hot X, Y - offset from hot Y,
//              L - length of non-transparent horizontal segment (in points)
//              colors - RGB colors for each point of segment
//          1,0,0,0,0,0,0,0,0,0,0,0
   0, 0, 1, B,
//          1,1,0,0,0,0,0,0,0,0,0,0,
   1, 0, 2, B,B,
//          1,2,1,0,0,0,0,0,0,0,0,0,
   2, 0, 3, B,W,B,
//          1,2,2,1,0,0,0,0,0,0,0,0,
   3, 0, 4, B,W,W,B,
//          1,2,2,2,1,0,0,0,0,0,0,0,
   4, 0, 5, B,W,W,W,B,
//          1,2,2,2,2,1,0,0,0,0,0,0,
   5, 0, 6, B,W,W,W,W,B,
//          1,2,2,2,2,2,1,0,0,0,0,0,
   6, 0, 7, B,W,W,W,W,W,B,
//          1,2,2,2,2,2,2,1,0,0,0,0,
   7, 0, 8, B,W,W,W,W,W,W,B,
//          1,2,2,2,2,2,2,2,1,0,0,0,
   8, 0, 9, B,W,W,W,W,W,W,W,B,
//          1,2,2,2,2,2,2,2,2,1,0,0,
   9, 0,10, B,W,W,W,W,W,W,W,W,B,
//          1,2,2,2,2,2,2,2,2,2,1,0,
  10, 0,11, B,W,W,W,W,W,W,W,W,W,B,
//          1,2,2,2,2,2,2,1,1,1,1,1,
  11, 0,12, B,W,W,W,W,W,W,B,B,B,B,B,
//          1,2,2,2,1,2,2,1,0,0,0,0,
  12, 0, 8, B,W,W,W,B,W,W,B,
//          1,2,2,1,1,2,2,1,0,0,0,0,
  13, 0, 8, B,W,W,B,B,W,W,B,
//          1,2,1,0,0,       1,2,2,1,0,0,0,
  14, 0, 3, B,W,B, 14, 5, 4, B,W,W,B,
//          1,1,0,0,0,       1,2,2,1,0,0,0,
  15, 0, 2, B,B,   15, 5, 4, B,W,W,B,
//          1,0,0,0,0,0,       1,2,2,1,0,0,
  16, 0, 1, B,     16, 6, 4,   B,W,W,B,
//          0,0,0,0,0,0,1,2,2,1,0,0,
  17, 6, 4,             B,W,W,B,
//          0,0,0,0,0,0,0,1,2,2,1,0,
  18, 7, 4,               B,W,W,B,
//          0,0,0,0,0,0,0,1,2,2,1,0,
  19, 7, 4,               B,W,W,B,
//          0,0,0,0,0,0,0,0,1,1,0,0
  20, 8, 2,                 B,B
};

void MousePointerInit (tWinManager* pWinManager, const int32* pMousePointerDataArray, uint ElementsPerArray);

void DrawWinMoveResizeFrame (tWinManager* pWinManager,
                             tWindow* pWindow, const tRectSetElement* pDrawRect);

int  WinManager_Init (tWinManager* pWinManager, const tWinManagerInit* pWinManagerInit)
{
  tDisplayInit DisplayInit;
  int i;

  pWinManager->pDisplay      = pWinManagerInit->pDisplay;
  pWinManager->VirtScrWidth  = pWinManagerInit->VirtScrWidth;
  pWinManager->VirtScrHeight = pWinManagerInit->VirtScrHeight;
  pWinManager->ScrWidth      = pWinManagerInit->ScrWidth;
  pWinManager->ScrHeight     = pWinManagerInit->ScrHeight;
  pWinManager->ScrPosX       = pWinManagerInit->ScrPosX;
  pWinManager->ScrPosY       = pWinManagerInit->ScrPosY;
  pWinManager->ColorDepth    = pWinManagerInit->ColorDepth;

  DisplayInit.Width      = pWinManager->ScrWidth;
  DisplayInit.Height     = pWinManager->ScrHeight;
  DisplayInit.ColorDepth = pWinManager->ColorDepth;
  if (!Display_Init (pWinManager->pDisplay, &DisplayInit))
    return 0;

  for (i=0; i<wzg_COUNT; i++)
    pWinManager->aGroupTopWindows[i] =
      pWinManager->aGroupBottomWindows[i] = NULL;

  pWinManager->MousePosX = pWinManager->ScrWidth >> 1;
  pWinManager->MousePosY = pWinManager->ScrHeight >> 1;
  pWinManager->MousePointerWindowCount = 0;
  MousePointerInit (pWinManager, aMousePointerNormal, GetArrayElementCount(aMousePointerNormal));

  for (i=0; i<4; i++)
  {
    InitWindow (&pWinManager->aMoveResizeWindows[i],
                0, 0, 0, 0,
                wzg_MOVE_RESIZE_FRAME,
                &DrawWinMoveResizeFrame,
                NULL);
    pWinManager->aMoveResizeWindows[i].IsHidden = 1;
    AddWindow (pWinManager, &pWinManager->aMoveResizeWindows[i]);
  }

  return 1;
}

void InitWindow (tWindow* pWindow, int x1, int y1, int x2, int y2,
                 tWindowZGroup ZGroup,
                 void (*pDraw)(struct tWinManager*, struct tWindow*, const tRectSetElement*),
                 void (*pEventHandler)(struct tWinManager*, struct tWindow*, const tWindowEvent*))
{
  pWindow->IsMovable = 1;
  pWindow->IsResizable = 0;
  pWindow->IsHidden = 0;
  pWindow->Rect.x1 = x1;
  pWindow->Rect.y1 = y1;
  pWindow->Rect.x2 = x2;
  pWindow->Rect.y2 = y2;
  pWindow->ZGroup = ZGroup;
  pWindow->pSubView =
  pWindow->pOwnerView =
  pWindow->pNextSubView =
  pWindow->pPrevSubView = NULL;
  pWindow->pDraw = pDraw;
  pWindow->pEventHandler = pEventHandler;
}

void InsertWindowSubView (tWindow* pWindow, tWindow* pSubView)
{
  if (pWindow->pSubView == NULL)
    pWindow->pSubView = pSubView;
  else
  {
    tWindow* pW = pWindow->pSubView;
    while (pW->pNextSubView != NULL)
      pW = pW->pNextSubView;
    pW->pNextSubView = pSubView;
    pSubView->pPrevSubView = pW;
  }
  pSubView->pOwnerView = pWindow;
}

void DeleteWindowSubView (tWindow* pSubView)
{
  int f;
  f  = (pSubView->pPrevSubView == NULL);
  f |= (pSubView->pNextSubView == NULL) << 1;
  switch (f)
  {
    case 0:
      pSubView->pNextSubView->pPrevSubView = pSubView->pPrevSubView;
    case 2:
      pSubView->pPrevSubView->pNextSubView = pSubView->pNextSubView;
    break;
    case 1:
    case 3:
      pSubView->pOwnerView->pSubView = pSubView->pNextSubView;
    break;
  }
}

void ForEachWindowView (tWinManager* pWinManager, tWindow* pWindow,
                        void (*pAction)(tWinManager*, tWindow*, void*),
                        void* pData)
{
  tWindow* pW;

  pAction (pWinManager, pWindow, pData);

  for (pW = pWindow->pSubView; pW != NULL; pW = pW->pNextSubView)
    ForEachWindowView (pWinManager, pW, pAction, pData);
}

void WinManager_Done (tWinManager* pWinManager)
{
  Display_Done (pWinManager->pDisplay);
}

void WinManager_ThreadFunction (tWinManager* pWinManager)
{
}

inline tWindow* FindUpperZGWindow (tWinManager* pWinManager, tWindowZGroup ZGroup)
{
  int i;
  tWindow* res = NULL;

  for (i=ZGroup+1; i<wzg_COUNT; i++)
    if ((res=pWinManager->aGroupBottomWindows[i]) != NULL)
      break;

  return res;
}

inline tWindow* FindLowerZGWindow (tWinManager* pWinManager, tWindowZGroup ZGroup)
{
  int i;
  tWindow* res = NULL;

  for (i=ZGroup-1; i>=0; i--)
    if ((res=pWinManager->aGroupTopWindows[i]) != NULL)
      break;

  return res;
}

static void AddWindowToListTop (tWinManager* pWinManager, tWindow* pWindow)
{
  if (pWinManager->aGroupTopWindows[pWindow->ZGroup] == NULL)
  {
    pWinManager->aGroupTopWindows[pWindow->ZGroup] =
      pWinManager->aGroupBottomWindows[pWindow->ZGroup] = pWindow;
    pWindow->pUpper = FindUpperZGWindow (pWinManager, pWindow->ZGroup);
    pWindow->pLower = FindLowerZGWindow (pWinManager, pWindow->ZGroup);
    if (pWindow->pUpper != NULL)
      pWindow->pUpper->pLower = pWindow;
    if (pWindow->pLower != NULL)
      pWindow->pLower->pUpper = pWindow;
  }
  else
  {
    pWindow->pLower = pWinManager->aGroupTopWindows[pWindow->ZGroup];
    if ((pWindow->pUpper = pWindow->pLower->pUpper) != NULL)
      pWindow->pUpper->pLower = pWindow;
    pWindow->pLower->pUpper = pWindow;
    pWinManager->aGroupTopWindows[pWindow->ZGroup] = pWindow;
  }
}

static int IsTopWindowInGroup (tWinManager* pWinManager, tWindow* pWindow)
{
  return pWinManager->aGroupTopWindows[pWindow->ZGroup] == pWindow;
}

static void RemoveWindowFromList (tWinManager* pWinManager, tWindow* pWindow)
{
  int f1, f2;
  f1  = (pWindow->pUpper == NULL);
  f1 |= (pWindow->pLower == NULL) << 1;
  f2  = (pWinManager->aGroupTopWindows[pWindow->ZGroup]    == pWindow);
  f2 |= (pWinManager->aGroupBottomWindows[pWindow->ZGroup] == pWindow) << 1;
  switch (f1)
  {
    case 0:
      pWindow->pLower->pUpper = pWindow->pUpper;
      pWindow->pUpper->pLower = pWindow->pLower;
    break;
    case 1:
      pWindow->pLower->pUpper = NULL;
    break;
    case 2:
      pWindow->pUpper->pLower = NULL;
    break;
    case 3:
    break;
  }
  switch (f2)
  {
    case 0:
    break;
    case 1:
      pWinManager->aGroupTopWindows[pWindow->ZGroup] = pWindow->pLower;
    break;
    case 2:
      pWinManager->aGroupBottomWindows[pWindow->ZGroup] = pWindow->pUpper;
    break;
    case 3:
      pWinManager->aGroupTopWindows[pWindow->ZGroup] =
        pWinManager->aGroupBottomWindows[pWindow->ZGroup] = NULL;
    break;
  }
}

static void MoveWindowToListTop (tWinManager* pWinManager, tWindow* pWindow)
{
  RemoveWindowFromList (pWinManager, pWindow);
  AddWindowToListTop (pWinManager, pWindow);
}

static tWindow* FindNextClipWindow (tWinManager* pWinManager, tWindow* pWindow,
                                    tWindow* pLastClipWindow)
{
  tWindow* res = NULL;
  tWindow* pW;

l:
  if (pLastClipWindow == NULL)
  {
    if (pWindow->pNextSubView != NULL)
      pLastClipWindow = res = pWindow->pNextSubView;
    else
    {
      pW = pWindow;
      while (pW->pOwnerView != NULL)
        pW = pW->pOwnerView;
      pLastClipWindow = res = pW->pUpper;
    }
    if (res == NULL)
      return res;
  }
  else
  {
    if (pLastClipWindow->pNextSubView != NULL)
      pLastClipWindow = res = pLastClipWindow->pNextSubView;
    else
    {
      pW = pLastClipWindow;
      while (pW->pOwnerView != NULL)
        pW = pW->pOwnerView;
      pLastClipWindow = res = pW->pUpper;
    }
    if (res == NULL)
      return res;
  }
  if (res->IsHidden)
    goto l;

  return res;
}

static void DrawWindowRecursion (tWinManager* pWinManager, tWindow* pWindow,
                                 tWindow* pClipWindow, tRectSetElement* pVisibleRect)
{
  tRectSetElement aDiffRect[4];
  int i, n;

  if (pWindow->pSubView != NULL)
  {
    tWindow* pW;
    for (pW = pWindow->pSubView; pW != NULL; pW = pW->pNextSubView)
      DrawWindowRecursion (pWinManager, pW,
                           FindNextClipWindow (pWinManager, pW, pClipWindow),
                           pVisibleRect);
    return;
  }

  if (pClipWindow == NULL)
  {
#if 0
    Display_Box (pWinManager->pDisplay,
                 pVisibleRect->x1,
                 pVisibleRect->y1,
                 pVisibleRect->x2,
                 pVisibleRect->y2,
                 0,
                 0xFFFFFFUL);
    getch();
#endif
    if (pWindow->pDraw != NULL)
      pWindow->pDraw (pWinManager, pWindow, pVisibleRect);
    return;
  }

  n = RectSet_GetDifferenceRects (pVisibleRect, &pClipWindow->Rect, aDiffRect);
  for (i=0; i<n; i++)
    DrawWindowRecursion (pWinManager, pWindow,
                         FindNextClipWindow (pWinManager, pWindow, pClipWindow),
                         &aDiffRect[i]);
}

static void DrawClippedWindow (tWinManager* pWinManager, tWindow* pWindow,
                               tRectSetElement* pVisibleRect)
{
  if (pWindow->IsHidden)
    return;

  if (pWindow->pSubView != NULL)
  {
    tWindow* pW;
    for (pW = pWindow->pSubView; pW != NULL; pW = pW->pNextSubView)
    {
      int n;
      tRectSetElement rect;
      if (pVisibleRect != NULL)
      {
        n = RectSet_GetIntersectRect (&pW->Rect, pVisibleRect, &rect);
      }
      else
      {
        rect = pW->Rect;
        n = 1;
      }
      if (n)
        DrawWindowRecursion (pWinManager, pW,
                             FindNextClipWindow (pWinManager, pW, NULL),
                             &rect);
    }
  }
  else
  {
    int n;
    tRectSetElement rect;
    if (pVisibleRect != NULL)
    {
      n = RectSet_GetIntersectRect (&pWindow->Rect, pVisibleRect, &rect);
    }
    else
    {
      rect = pWindow->Rect;
      n = 1;
    }
    if (n)
      DrawWindowRecursion (pWinManager, pWindow,
                           FindNextClipWindow (pWinManager, pWindow, NULL),
                           &rect);
  }
}

void DrawWindow (tWinManager* pWinManager, tWindow* pWindow)
{
  DrawClippedWindow (pWinManager, pWindow, NULL);
}

static void DrawWindowAndLowers (tWinManager* pWinManager, tWindow* pWindow,
                                 tRectSetElement* pVisibleRect)
{
  tWindow *pW;

  for (pW = pWindow; pW != NULL; pW = pW->pLower)
    DrawClippedWindow (pWinManager, pW, pVisibleRect);
}

void HideWindow (tWinManager* pWinManager, tWindow* pWindow)
{
  if (pWindow->IsHidden)
    return;
  pWindow->IsHidden = 1;
  DrawWindowAndLowers (pWinManager, pWindow, &pWindow->Rect);
}

void ShowWindow (tWinManager* pWinManager, tWindow* pWindow)
{
  if (!pWindow->IsHidden)
    return;
  pWindow->IsHidden = 0;
  DrawWindow (pWinManager, pWindow);
}

void RemoveWindow (tWinManager* pWinManager, tWindow* pWindow)
{
  tWindow* pW = pWindow->pLower;
  RemoveWindowFromList (pWinManager, pWindow);
  if (pW != NULL)
    DrawWindowAndLowers (pWinManager, pW, &pWindow->Rect);
}

void AddWindow (tWinManager* pWinManager, tWindow* pWindow)
{
  AddWindowToListTop (pWinManager, pWindow);
  DrawWindow (pWinManager, pWindow);
}

void SelectWindow (tWinManager* pWinManager, tWindow* pWindow)
{
  MoveWindowToListTop (pWinManager, pWindow);
  DrawWindow (pWinManager, pWindow);
}

tWindow* FindWindowUnderMousePointer (tWinManager* pWinManager)
{
  tWindow* res = NULL;
  tWindow* pW;

  pW = FindLowerZGWindow (pWinManager, wzg_MOUSE_POINTER);
  while (pW != NULL)
  {
    if
    (
      (!pW->IsHidden) &&
      (pW->Rect.x1 <= pWinManager->MousePosX) &&
      (pW->Rect.y1 <= pWinManager->MousePosY) &&
      (pW->Rect.x2 >= pWinManager->MousePosX) &&
      (pW->Rect.y2 >= pWinManager->MousePosY)
    )
    {
      res = pW;
      break;
    }
    pW = pW->pLower;
  }

  return res;
}

typedef struct tMoveVector {
  int dx, dy;
} tMoveVector;

static void MoveWindowView (tWinManager* pWinManager, tWindow* pWindow, void* pData)
{
  tMoveVector* pMoveVector = pData;
  pWindow->Rect.x1 += pMoveVector->dx;
  pWindow->Rect.x2 += pMoveVector->dx;
  pWindow->Rect.y1 += pMoveVector->dy;
  pWindow->Rect.y2 += pMoveVector->dy;
}

void MoveWindow (tWinManager* pWinManager, tWindow* pWindow, int dx, int dy)
{
  int i, n;
  tRectSetElement rect, aDiffRect[4];
  tWindow* pW;
  tMoveVector MoveVector;

  if (!pWindow->IsMovable)
    return;

  rect = pWindow->Rect;
  MoveVector.dx = dx;
  MoveVector.dy = dy;
  ForEachWindowView (pWinManager, pWindow, &MoveWindowView, &MoveVector);

  DrawWindow (pWinManager, pWindow);

  pW = pWindow->pLower;
  if (pW != NULL)
  {
    n = RectSet_GetDifferenceRects (&rect, &pWindow->Rect, aDiffRect);
    for (i=0; i<n; i++)
      DrawWindowAndLowers (pWinManager, pW, &aDiffRect[i]);
  }
}

static void WinMousePointerDraw (tWinManager* pWinManager,
                                 tWindow* pWindow, const tRectSetElement* pDrawRect)
{
  int x;
  const uint32* p = ((tMousePointerWindow*)pWindow)->pMousePointerPixels;
  for (x=pWindow->Rect.x1; x<=pWindow->Rect.x2; x++)
    Display_Pixel (pWinManager->pDisplay, x, pWindow->Rect.y1, *p++);
}

void MousePointerInit (tWinManager* pWinManager, const int32* pMousePointerDataArray, uint ElementsPerArray)
{
  uint i;
  const int32* p = pMousePointerDataArray;
  tMousePointerWindow* pW = &pWinManager->aMousePointerWindow[0];

  // Delete windows of old mouse pointer (if any)
  for (i=0; i<pWinManager->MousePointerWindowCount; i++)
  {
    RemoveWindow (pWinManager, (tWindow*)&pW[i]);
  }

  // Add windows for new mouse pointer
  pWinManager->MousePointerWindowCount = 0;
  for
  (
    i=0;
    (p<pMousePointerDataArray+ElementsPerArray) &&
      (i<WM_MAX_WINDOWS_FOR_MOUSE_POINTER);
    i++
  )
  {
    InitWindow (&pW[i].Window,
                pWinManager->MousePosX+p[1],
                pWinManager->MousePosY+p[0],
                pWinManager->MousePosX+p[1]+p[2]-1,
                pWinManager->MousePosY+p[0],
                wzg_MOUSE_POINTER,
                &WinMousePointerDraw,
                NULL);
    pW[i].pMousePointerPixels = (uint32*)&p[3];
    p += 3 + p[2];
    AddWindow (pWinManager, &pW[i].Window);
    pWinManager->MousePointerWindowCount++;
  }
}

void MoveMousePointer (tWinManager* pWinManager, int dx, int dy)
{
  int i;
  pWinManager->MousePosX += dx;
  pWinManager->MousePosY += dy;
  for (i=0; i<pWinManager->MousePointerWindowCount; i++)
    MoveWindow (pWinManager, (tWindow*)&pWinManager->aMousePointerWindow[i], dx, dy);
}

void DrawWinMoveResizeFrame (tWinManager* pWinManager,
                             tWindow* pWindow, const tRectSetElement* pDrawRect)
{
  Display_Box (pWinManager->pDisplay,
               pDrawRect->x1,
               pDrawRect->y1,
               pDrawRect->x2,
               pDrawRect->y2,
               1,
               0x808080UL);
}

void StartMoveResize (tWinManager* pWinManager, tWindow* pWindow)
{
  int i;

  for (i=0; i<4; i++)
    HideWindow (pWinManager, &pWinManager->aMoveResizeWindows[i]);

  pWinManager->aMoveResizeWindows[0].Rect = pWindow->Rect;
  pWinManager->aMoveResizeWindows[0].Rect.y2 = pWindow->Rect.y1+1;
  pWinManager->aMoveResizeWindows[1].Rect = pWindow->Rect;
  pWinManager->aMoveResizeWindows[1].Rect.y1 = pWindow->Rect.y2-1;
  pWinManager->aMoveResizeWindows[2].Rect = pWindow->Rect;
  pWinManager->aMoveResizeWindows[2].Rect.x2 = pWindow->Rect.x1+1;
  pWinManager->aMoveResizeWindows[3].Rect = pWindow->Rect;
  pWinManager->aMoveResizeWindows[3].Rect.x1 = pWindow->Rect.x2-1;

  for (i=0; i<4; i++)
    ShowWindow (pWinManager, &pWinManager->aMoveResizeWindows[i]);
}

void StopMoveResize (tWinManager* pWinManager, tWindow* pWindow)
{
  int i;

  for (i=0; i<4; i++)
    HideWindow (pWinManager, &pWinManager->aMoveResizeWindows[i]);
}

void MoveMoveResizeFrame (tWinManager* pWinManager, int dx, int dy)
{
  int i;

  for (i=0; i<4; i++)
    MoveWindow (pWinManager, &pWinManager->aMoveResizeWindows[i], dx, dy);
}

#if 01
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include <go32.h>
#include <dpmi.h>

#include "../ComDefs.h"
#include "../ADTCntnr/ADTFifo.h"

#include "StatText.h"
#include "Fnt8x16.h"

typedef struct tWinSolidColor {
  tWindow Window;
  uint32 color;
} tWinSolidColor;

void DrawWinSolidColor (tWinManager* pWinManager,
                        tWindow* pWindow, const tRectSetElement* pDrawRect)
{
  Display_Box (pWinManager->pDisplay,
               pDrawRect->x1,
               pDrawRect->y1,
               pDrawRect->x2,
               pDrawRect->y2,
               1,
               ((tWinSolidColor*)pWindow)->color);
}

uchar aBMP[768][1024][3];
void LoadBMP1024x768x24bpp (char *name)
{
  uchar BMPHeader[54];
  FILE *f;
  int x, y;
  f = fopen (name, "rb");
  if (f == NULL)
    return;
  fread (&BMPHeader, sizeof(BMPHeader), 1, f);
  memset (aBMP, 0, sizeof(aBMP));
  for (y=0;y<768;y++)
    for (x=0;x<1024;x++)
    {
      uchar rgb[3];
      fread (&rgb, sizeof(rgb), 1, f);
      // account for upside-down
      aBMP[768-1-y][x][0] = rgb[0]; // B
      aBMP[768-1-y][x][1] = rgb[1]; // G
      aBMP[768-1-y][x][2] = rgb[2]; // R
    }
  fclose (f);
}

typedef struct tWinBitmap {
  tWindow Window;
} tWinBitmap;

void DrawWinBitmap (tWinManager* pWinManager,
                    tWindow* pWindow, const tRectSetElement* pDrawRect)
{
  Display_Bitmap (pWinManager->pDisplay,
                  pDrawRect->x1,
                  pDrawRect->y1,
                  (void*)aBMP,
                  dcd_24BPP,
                  1024,
                  768,
                  pDrawRect->x1 - pWindow->Rect.x1+1024-640,
                  pDrawRect->y1 - pWindow->Rect.y1+240,
                  pDrawRect->x2 - pWindow->Rect.x1+1024-640,
                  pDrawRect->y2 - pWindow->Rect.y1+240
                  );
}

typedef struct tWinDummy {
  tWindow Window;
} tWinDummy;

  tDisplay Display;
  tWinManager WinManager;
  tWinManagerInit WinManagerInit={&Display, 640, 480, dcd_4BPP, 640, 480, 0, 0};

#if 0
#define tWinDummy       tWinSolidColor
#define tWinBitmap      tWinSolidColor
#define tWinStaticTex   tWinSolidColor
#define DrawWinBitmap   DrawWinSolidColor
#endif

  tWinSolidColor WinDesktopWallpaper;
  tWinSolidColor WinDesktopIcon1;
  tWinSolidColor WinDesktopIcon2;
  tWinBitmap Win1;
  tWinBitmap Win2;

  tWinDummy      Win3;
  tWinSolidColor Win3Sub1;
  tWinBitmap     Win3Sub2;
  tWinStaticText Win3Sub3;

  tWinDummy      Win4;
  tWinSolidColor Win4Sub1;
  tWinStaticText aWin4SubTexts[16];

uint32 aExactVGAColor[16] =
{
  COLOR_MAKE(0x00, 0x00, 0x00, 0x00),
  COLOR_MAKE(0x00, 0x00, 0x00, 0x80),
  COLOR_MAKE(0x00, 0x00, 0x80, 0x00),
  COLOR_MAKE(0x00, 0x00, 0x80, 0x80),
  COLOR_MAKE(0x00, 0x80, 0x00, 0x00),
  COLOR_MAKE(0x00, 0x80, 0x00, 0x80),
  COLOR_MAKE(0x00, 0x80, 0x80, 0x00),
  COLOR_MAKE(0x00, 0x80, 0x80, 0x80),
  COLOR_MAKE(0x00, 0x40, 0x40, 0x40),
  COLOR_MAKE(0x00, 0x00, 0x00, 0xFF),
  COLOR_MAKE(0x00, 0x00, 0xFF, 0x00),
  COLOR_MAKE(0x00, 0x00, 0xFF, 0xFF),
  COLOR_MAKE(0x00, 0xFF, 0x00, 0x00),
  COLOR_MAKE(0x00, 0xFF, 0x00, 0xFF),
  COLOR_MAKE(0x00, 0xFF, 0xFF, 0x00),
  COLOR_MAKE(0x00, 0xFF, 0xFF, 0xFF)
};

typedef struct tDosMouseEvent {
  int ButtonsState;
  int NewX;
  int NewY;
  int dummy;
} tDosMouseEvent;

#define MOUSE_FIFO_LEN  256
tDosMouseEvent aDosMouseEvent[MOUSE_FIFO_LEN];
tADTFifo DosMouseEventFifo;

// DPMI variables:
static _go32_dpmi_seginfo mouse_seginfo;
static _go32_dpmi_registers mouse_regs;

/* position_mouse:
 *  Moves the mouse to screen position x, y. This is safe to call even
 *  when a mouse pointer is being displayed.
 */
void position_mouse (int x, int y)
{
  __dpmi_regs r;
  r.x.ax = 4;
  r.x.cx = x * 8;
  r.x.dx = y * 8;
  __dpmi_int(0x33, &r); 
}

/* set_mouse_range:
 *  Sets the screen area within which the mouse can move. Pass the top left 
 *  corner and the bottom right corner (inclusive). If you don't call this 
 *  function the range defaults to (0, 0, SCREEN_W-1, SCREEN_H-1).
 */
void set_mouse_range (int x1, int y1, int x2, int y2)
{
  __dpmi_regs r;

  r.x.ax = 7;
  r.x.cx = x1 * 8;
  r.x.dx = x2 * 8;
  __dpmi_int(0x33, &r);         /* set horizontal range */

  r.x.ax = 8;
  r.x.cx = y1 * 8;
  r.x.dx = y2 * 8;
  __dpmi_int(0x33, &r);         /* set vertical range */
}

/* set_mouse_speed:
 *  Sets the mouse speed. Larger values of xspeed and yspeed represent 
 *  slower mouse movement: the default for both is 2.
 */
void set_mouse_speed (int xspeed, int yspeed)
{
  __dpmi_regs r;

  r.x.ax = 15;
  r.x.cx = xspeed;
  r.x.dx = yspeed;
  __dpmi_int(0x33, &r); 
}

/* mouseint:
 *  Mouse movement callback for the int 33 mouse driver.
 */
static void mouseint (_go32_dpmi_registers *r)
{
  tDosMouseEvent e;
#if 0
  int b = r->x.bx;;
  int lastx = WinManager.MousePosX, lasty = WinManager.MousePosY;

  // button state and mouse coordinates:
  MoveMousePointer (&WinManager, r->x.cx/8 - lastx, r->x.dx/8 - lasty);
#else
  e.ButtonsState = r->x.bx;
  e.NewX = r->x.cx/8;
  e.NewY = r->x.dx/8;
  ADTFifo_Write (&DosMouseEventFifo, &e);
#endif
}

/* install_mouse:
 *  Installs the mouse handler. You must do this before using any
 *  other mouse functions. Return 0 if it can't find a mouse driver,
 *  1 otherwise
 */
int install_mouse()
{
  __dpmi_regs r;
  r.x.ax = 0;
  __dpmi_int(0x33, &r);         /* initialise mouse driver */

  if (r.x.ax == 0)
     return 0;

  /* create real mode callback for the int33 driver */
  mouse_seginfo.pm_offset = (uint32)&mouseint;
  mouse_seginfo.pm_selector = _my_cs();
  _go32_dpmi_allocate_real_mode_callback_retf(&mouse_seginfo, &mouse_regs);

  r.x.ax = 0x0C;
  r.x.cx = 0x7F;
  r.x.dx = mouse_seginfo.rm_offset;
  r.x.es = mouse_seginfo.rm_segment;
  __dpmi_int(0x33, &r);         /* install callback */

  set_mouse_speed (8, 8);       /* set sensitivity */
  set_mouse_range (0, 0, WinManager.ScrWidth-1, WinManager.ScrHeight-1);
  position_mouse (WinManager.MousePosX, WinManager.MousePosY);

  ADTFifo_Init (&DosMouseEventFifo, aDosMouseEvent,
                sizeof(tDosMouseEvent), MOUSE_FIFO_LEN);

  return 1;
}

/* remove_mouse:
 *  Removes the mouse handler.
 */
void remove_mouse()
{
  __dpmi_regs r;

  r.x.ax = 0x0C;
  r.x.cx = 0;
  r.x.dx = 0;
  r.x.es = 0;
  __dpmi_int(0x33, &r);         /* install NULL callback */

  set_mouse_speed (8, 16);      /* reset sensitivity */

  _go32_dpmi_free_real_mode_callback(&mouse_seginfo);
}

#include <time.h>

int main()
{
  int m = 0;
  LoadBMP1024x768x24bpp ("vinca.bmp");
  int IsDelayedDraw = 1;

  if (!WinManager_Init (&WinManager, &WinManagerInit))
    goto lend;

  m = install_mouse();

//  getch();

  InitWindow (&WinDesktopWallpaper.Window,
              0, 0, 639, 479,
              wzg_DESKTOP_WALLPAPER,
              &DrawWinSolidColor, NULL);
  WinDesktopWallpaper.Window.IsMovable = 0;
  WinDesktopWallpaper.color = 0x008080UL;
  AddWindow (&WinManager, &WinDesktopWallpaper.Window);
//  getch();

  InitWindow (&WinDesktopIcon1.Window,
              16, 16, 16+15, 16+15,
              wzg_DESKTOP_ICON,
              &DrawWinSolidColor, NULL);
  WinDesktopIcon1.color = 0xFFFF00UL;
  AddWindow (&WinManager, &WinDesktopIcon1.Window);
//  getch();

  InitWindow (&WinDesktopIcon2.Window,
              48, 16, 48+15, 16+15,
              wzg_DESKTOP_ICON,
              &DrawWinSolidColor, NULL);
  WinDesktopIcon2.color = 0x808080UL;
  AddWindow (&WinManager, &WinDesktopIcon2.Window);
//  getch();

  InitWindow (&Win1.Window,
              50, 50, 50+299, 50+199,
              wzg_WINDOW,
              &DrawWinBitmap, NULL);
  AddWindow (&WinManager, &Win1.Window);
//  getch();

  InitWindow (&Win2.Window,
              330, 200, 330+299, 200+199,
              wzg_WINDOW,
              &DrawWinBitmap, NULL);
  AddWindow (&WinManager, &Win2.Window);
//  getch();

  WinDesktopWallpaper.color = 0x000080UL;
  DrawWindow (&WinManager, &WinDesktopWallpaper.Window);
//  getch();

  MoveWindow (&WinManager, &WinDesktopIcon2.Window, -32, 32);
//  getch();

  RemoveWindow (&WinManager, &WinDesktopIcon2.Window);
//  getch();

  AddWindow (&WinManager, &WinDesktopIcon2.Window);
//  getch();

  SelectWindow (&WinManager, &Win1.Window);
//  getch();

  SelectWindow (&WinManager, &Win2.Window);
//  getch();

  HideWindow (&WinManager, &Win1.Window);
//  getch();

  HideWindow (&WinManager, &Win2.Window);
//  getch();

  ShowWindow (&WinManager, &Win2.Window);
//  getch();

  ShowWindow (&WinManager, &Win1.Window);
//  getch();

  InitWindow (&Win3.Window,
              100, 100, 100+299, 100+199,
              wzg_WINDOW,
              NULL, NULL);

  InitWindow (&Win3Sub1.Window,
              Win3.Window.Rect.x1,
              Win3.Window.Rect.y1,
              Win3.Window.Rect.x2,
              Win3.Window.Rect.y2,
              wzg_WINDOW,
              &DrawWinSolidColor, NULL);
  Win3Sub1.color = 0xFFFFFFUL;
  InsertWindowSubView (&Win3.Window, &Win3Sub1.Window);

  InitWindow (&Win3Sub2.Window,
              Win3.Window.Rect.x1+2,
              Win3.Window.Rect.y1+2+16+2,
              Win3.Window.Rect.x2-2,
              Win3.Window.Rect.y2-2,
              wzg_WINDOW,
              &DrawWinBitmap, NULL);
  InsertWindowSubView (&Win3.Window, &Win3Sub2.Window);

  InitWindowStaticText (&Win3Sub3,
                        Win3.Window.Rect.x1+2,
                        Win3.Window.Rect.y1+2,
                        Win3.Window.Rect.x2-2,
                        Win3.Window.Rect.y1+2+15,
                        " vinca.bmp ",
                        0x000080UL,
                        0x00FFFFUL,
                        aFont8x16RusAlt);
  InsertWindowSubView (&Win3.Window, &Win3Sub3.Window);

  AddWindow (&WinManager, &Win3.Window);
//  getch();

  InitWindow (&Win4.Window,
              120,
              120,
              120+40*8+4-1,
              120+GetArrayElementCount(aWin4SubTexts)*16+4-1,
              wzg_WINDOW,
              NULL, NULL);

  InitWindow (&Win4Sub1.Window,
              Win4.Window.Rect.x1,
              Win4.Window.Rect.y1,
              Win4.Window.Rect.x2,
              Win4.Window.Rect.y2,
              wzg_WINDOW,
              &DrawWinSolidColor, NULL);
  Win4Sub1.color = 0x404040UL;
  InsertWindowSubView (&Win4.Window, &Win4Sub1.Window);

  if (01)
  {
    int i;
    for (i=0; i<GetArrayElementCount(aWin4SubTexts); i++)
    {
      InitWindowStaticText (&aWin4SubTexts[i],
                            Win4.Window.Rect.x1+2,
                            Win4.Window.Rect.y1+2+i*16,
                            Win4.Window.Rect.x2-2,
                            Win4.Window.Rect.y1+2+i*16+15,
                            "0123456789 -- ABCDEFGHIJKLMNOPQRSTUVWXYZ",
//                            "                                        ",
                            aExactVGAColor[i],
                            aExactVGAColor[i^7],
                            aFont8x16RusAlt);
      InsertWindowSubView (&Win4.Window, &aWin4SubTexts[i].Window);
    }
  }

  AddWindow (&WinManager, &Win4.Window);

//  SelectWindow (&WinManager, &Win2.Window);

  for (;;)
  {
    int k;
    static int hold=0, adx=0, ady=0;
    static tWindow* pDraggedWin = NULL;
    static int dx, dy;
    static clock_t t;

    if (kbhit())
    {
      k = getch();
      if (!k)
        k = getch();
    }
    else k = 0;
    if (k == 27) break;
    if (k == 32) IsDelayedDraw ^= 1;
    if (ADTFifo_ReadAvail (&DosMouseEventFifo))
    {
      tDosMouseEvent e;
      int lastx = WinManager.MousePosX, lasty = WinManager.MousePosY;

      ADTFifo_Read (&DosMouseEventFifo, &e);
      dx = e.NewX - lastx;
      dy = e.NewY - lasty;
      MoveMousePointer (&WinManager, dx, dy);

      t = clock();

      if ((e.ButtonsState & 1) && (!hold))
      {
        pDraggedWin = FindWindowUnderMousePointer (&WinManager);
        if (pDraggedWin != NULL)
        {
          if (!IsTopWindowInGroup (&WinManager, pDraggedWin))
            SelectWindow (&WinManager, pDraggedWin);
          StartMoveResize (&WinManager, pDraggedWin);
          hold = 1;
          adx = 0;
          ady = 0;
        }
      }

      if (hold && (!(e.ButtonsState & 1)))
      {
        hold = 0;
        StopMoveResize (&WinManager, pDraggedWin);
        MoveWindow (&WinManager, pDraggedWin, adx, ady);
      }

      if (hold)
      {
        adx += dx;
        ady += dy;
        MoveMoveResizeFrame (&WinManager, dx, dy);
      }
    }

    {
      clock_t t1 = clock();
      if (hold && (ady | adx) && ((t1-t>CLK_TCK/8) || !IsDelayedDraw))
      {
        t = t1;
        MoveWindow (&WinManager, pDraggedWin, adx, ady);
        ady = adx = 0;
      }
    }
  }

lend:
  if (m)
    remove_mouse();

  WinManager_Done (&WinManager);
  return 0;
}
#endif

